%Search for optimal path between start and and node using quad tree space
%decomposition
function Optimal_path_Fin =findOptimalPath(nodeS,nodeE,drevo,MAX_X,MAX_Y,draw)

OPEN_COUNT=0;
CLOSED_COUNT=0;



xval=drevo(nodeE).center(1);
yval=drevo(nodeE).center(2);
xTarget=xval;%X Coordinate of the Target
yTarget=yval;%Y Coordinate of the Target
idTarget=nodeE;


xval=drevo(nodeS).center(1);
yval=drevo(nodeS).center(2);
xStart=xval;%Starting Position
yStart=yval;%Starting Position
idStart=nodeS;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%LISTS USED FOR ALGORITHM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%OPEN LIST STRUCTURE
%--------------------------------------------------------------------------
%IS ON LIST 1/0 |X val |Y val |h(n) |g(n)|f(n)|id|idparent|
%--------------------------------------------------------------------------
OPEN=[];
OPEN_COUNT=0;
%CLOSED LIST STRUCTURE
%--------------
%X val | Y val |id |
%--------------
CLOSED=[];
CLOSED_COUNT=0;

idParentNodeOpen=1;

%set the starting node as the first node
xNode=xStart;
yNode=yStart;
idNode=nodeS;
OPEN_COUNT=1;
path_cost=0;
goal_distance=distance(xNode,yNode,xTarget,yTarget);
OPEN(OPEN_COUNT,:)=insert_open(xNode,yNode,path_cost,goal_distance,goal_distance,idNode,idParentNodeOpen);
OPEN(OPEN_COUNT,1)=0;
CLOSED_COUNT=CLOSED_COUNT+1;
CLOSED(CLOSED_COUNT,1)=xNode;
CLOSED(CLOSED_COUNT,2)=yNode;
CLOSED(CLOSED_COUNT,3)=idNode;
CLOSED(CLOSED_COUNT,4)=idParentNodeOpen;

NoPath=1;




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% START ALGORITHM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
while((xNode ~= xTarget || yNode ~= yTarget) && NoPath == 1)
 exp_array=expand_array(idNode,path_cost,xTarget,yTarget,CLOSED,MAX_X,MAX_Y,drevo);
 
 exp_count=size(exp_array,1);
 %UPDATE LIST OPEN WITH THE SUCCESSOR NODES
 %OPEN LIST FORMAT
 %--------------------------------------------------------------------------
 %IS ON LIST 1/0 |X val |Y val |h(n) |g(n)|f(n)|id|idparent|
 %--------------------------------------------------------------------------
 %EXPANDED ARRAY FORMAT
 %--------------------------------
 %|X val |Y val |h(n) |g(n)|f(n)| id |
 %--------------------------------
 for i=1:exp_count
    flag=0;
    for j=1:OPEN_COUNT
        if(exp_array(i,6) == OPEN(j,7))     % to zamenjaj le s preverbo id-jev drevesa
            OPEN(j,6)=min(OPEN(j,6),exp_array(i,5));
            if OPEN(j,6)== exp_array(i,5)
                %UPDATE PARENTS,gn,hn
                OPEN(j,4)=exp_array(i,3);
                OPEN(j,5)=exp_array(i,4);
                OPEN(j,8)=idParentNodeOpen;
            end;%End of minimum fn check
            flag=1;
        end;%End of node check
%         if flag == 1
%             break;
    end;%End of j for
    if flag == 0
        OPEN_COUNT = OPEN_COUNT+1;
        OPEN(OPEN_COUNT,:)=insert_open(exp_array(i,1),exp_array(i,2),exp_array(i,3),exp_array(i,4),exp_array(i,5),exp_array(i,6),idParentNodeOpen);
     end;%End of insert new element into the OPEN list
 end;%End of i for
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %Find out the node with the smallest fn 
 % index_min_node = min_fn(OPEN,OPEN_COUNT,xTarget,yTarget,nodeE);
  index_min_node = min_fn(OPEN,OPEN_COUNT,idTarget);
  if (index_min_node ~= -1)    
   %Set xNode and yNode to the node with minimum fn
   xNode=OPEN(index_min_node,2);
   yNode=OPEN(index_min_node,3);
   idNode=OPEN(index_min_node,7);
   
   path_cost=OPEN(index_min_node,4);%Update the cost of reaching the parent node
  %Move the Node to list CLOSED
  CLOSED_COUNT=CLOSED_COUNT+1;
  CLOSED(CLOSED_COUNT,1)=xNode;
  CLOSED(CLOSED_COUNT,2)=yNode;
  CLOSED(CLOSED_COUNT,3)=idNode; %id
  CLOSED(CLOSED_COUNT,4)=idParentNodeOpen;
  OPEN(index_min_node,1)=0;
  
  idParentNodeOpen=index_min_node;

 % plot(xNode +.5, yNode +.5,'*')
 % pause(0.25),drawnow
  
  else
      %No path exists to the Target!!
      NoPath=0;%Exits the loop!
  end;%End of index_min_node check
end;%End of While Loop





%Once algorithm has run The optimal path is generated by starting of at the
%last node(if it is the target node) and then identifying its parent node
%until it reaches the start node.This is the optimal path
i=size(CLOSED,1);
Optimal_path=[];
xval=CLOSED(i,1);
yval=CLOSED(i,2);
id=CLOSED(i,3);
pp=CLOSED(i,4); % find parent of the current cell in OPEN

i=1;

Optimal_path(i,1)=xval;
Optimal_path(i,2)=yval;
Optimal_path(i,3)=id;
i=i+1;

if ( (xval == xTarget) && (yval == yTarget))
    inode=0;
   %Traverse OPEN and determine the parent nodes
   parent_x = OPEN(pp,2);%node_index returns the index of the node
   parent_y = OPEN(pp,3);
   parent_id= OPEN(pp,7);       % id to the QT drevo

   
%   while( parent_x ~= xStart || parent_y ~= yStart)
  while( parent_id ~= idStart )
           Optimal_path(i,1) = parent_x;
           Optimal_path(i,2) = parent_y;
           Optimal_path(i,3) = parent_id;
           %Get the grandparents:-)

           pp=OPEN(pp,8);
           parent_x=OPEN(pp,2);%node_index returns the index of the node
           parent_y=OPEN(pp,3);
           parent_id= OPEN(pp,7);    % id to the QT drevo
           
           i=i+1;
    end; % end

    
 ss=size(Optimal_path,1);
 Optimal_path_Fin=[Optimal_path(ss:-1:1,1), Optimal_path(ss:-1:1,2),Optimal_path(ss:-1:1,3)]; 
   
    
   if(draw)   
         j=size(Optimal_path,1);
         %Plot the Optimal Path!
         hold on
         p=plot(Optimal_path(j,1),Optimal_path(j,2),'bo');
         j=j-1;
         for i=j:-1:1
          pause(.05);
          set(p,'XData',Optimal_path(i,1),'YData',Optimal_path(i,2));
          drawnow ;
         end;
         plot([Optimal_path(:,1) ; xStart],[Optimal_path(:,2) ; yStart]); 
        hold off
   end %if(draw)
   
else
 %pause(1);
 %h=msgbox('Sorry, No path exists to the Target!','warn');
 %uiwait(h,5);
  disp('***');
 disp('Sorry, No path exists to the Target!');
  disp('***');
end

end  % main function
%==========================================================================
%==========================================================================
%==========================================================================
%==========================================================================
%==========================================================================

%==========================================================================
%==========================================================================
%==========================================================================
%==== min_fn
%==========================================================================
%Function to return the Node with minimum fn
% This function takes the list OPEN as its input and returns the index of the
% node that has the least cost

%function i_min = min_fn(OPEN,OPEN_COUNT,xTarget,yTarget,idTarget)
function i_min = min_fn(OPEN,OPEN_COUNT,idTarget)
%  temp_array=[];
%  j=1;
%  k=1;
%  flag=0;
%  goal_index=0;
%  temp_min=0;
%  for j=1:OPEN_COUNT
%      if (OPEN(j,1)==1)
%          temp_array(k,:)=[OPEN(j,:) j];
% %          temp_array(k,10)=j;
%    %      if (OPEN(j,2)==xTarget && OPEN(j,3)==yTarget)
%           if (OPEN(j,7)==idTarget)
%              flag=1;
%              goal_index=j;%Store the index of the goal node
%          end;
%          k=k+1;
%      end;
%  end;%Get all nodes that are on the list open
%  if flag == 1 % one of the successors is the goal node so send this node
%      i_min=goal_index;
%      %return; % Grega dodal
%  end
%  %Send the index of the smallest node
%  
%  %GG=size(temp_array,2)
%  
%  if size(temp_array ~= 0)
%   [min_fn,temp_min]=min(temp_array(:,6));%Index of the smallest node in temp array
%   i_min=temp_array(temp_min,9);%Index of the smallest node in the OPEN array
%  else
%      i_min=-1;%The temp_array is empty i.e No more paths are available.
%  end;
 
 

%% Ta koda naredi enako kot zgornja zakomnetirana - le malo hitrejsa je
 
 ind=1:OPEN_COUNT;
 maska=OPEN(:,1)==1;
 
 tmp=OPEN(maska,6);
 indtmp=ind(maska);
 
 if size(tmp ~= 0)
   [min_fn,temp_min]=min(tmp);%Index of the smallest node in temp array
   i_min=indtmp(temp_min);%Index of the smallest node in the OPEN array
 else
     i_min=-1;%The temp_array is empty i.e No more paths are available.
 end;
 
end % function





%==========================================================================
%==========================================================================
%==========================================================================
%==== expand_array
%==========================================================================
%Function to return and expanded array
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%This function takes a node and returns the expanded list
%of successors,with the calculated fn values.
%The criteria being none of the successors are on the CLOSED list.
%GK 8.2009
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function exp_array=expand_array(node_id,hn,xTarget,yTarget,CLOSED,MAX_X,MAX_Y,drevo)

exp_array=[];
exp_count=1;
s_x=0;%X ordinate of the successor
s_y=0;%Y ordinate of the successor
c1=1;%Dummy counter for loop
c2=size(CLOSED,1);%Number of elements in CLOSED including the zeros
flag=0;%Determines if the node is to be put as a successor.


idS=drevo(node_id).visibleNodes;
distS=drevo(node_id).distVisibleNodes;
N=size(idS,2);

  for(i=1:N)
     s_x=drevo(idS(i)).center(1);
     s_y=drevo(idS(i)).center(2);
     
     exp_array(exp_count,1) = s_x;
     exp_array(exp_count,2) = s_y;
     exp_array(exp_count,3) = hn+distS(i);%cost of travelling to node
     exp_array(exp_count,4) = sqrt((xTarget-s_x)^2 + (yTarget-s_y)^2);
     exp_array(exp_count,5) = exp_array(exp_count,3)+exp_array(exp_count,4);%fn
     exp_array(exp_count,6) = idS(i);%id 
     
     exp_count=exp_count+1;
  end

end % function
%=========================================================================

%==========================================================================
%==========================================================================
%==========================================================================
%==== distance
%==========================================================================
function dist = distance(x1,y1,x2,y2)
%This function calculates the distance between any two cartesian 
%coordinates.
dist=sqrt((x1-x2)^2 + (y1-y2)^2);
end

%==========================================================================
%==========================================================================
%==========================================================================
%====insert_open
%==========================================================================
%Function to Populate the OPEN LIST
function new_row = insert_open(xval,yval,hn,gn,fn,idDrevo,idParentNodeOpen)
    %OPEN LIST FORMAT
    %--------------------------------------------------------------------------
    %IS ON LIST 1/0 |X val |Y val |h(n) |g(n)|f(n)|id|idparent|
    %-------------------------------------------------------------------------
    new_row=[1,8];
    new_row(1,1)=1;
    new_row(1,2)=xval;
    new_row(1,3)=yval;
    new_row(1,4)=hn;
    new_row(1,5)=gn;
    new_row(1,6)=fn;
    new_row(1,7)=idDrevo;
    new_row(1,8)=idParentNodeOpen;
end
%==========================================================================
%==========================================================================
%==========================================================================
%====
%==========================================================================

