% scriptDemoAMS
%========================== narisemo ovire
clear all, clear mex, close all

Animacija=0;




XMAX=10;      YMAX=10;        % dimenzije okolja
XOvirMax=1.5;  YOvirMax=1.5;      % max dimenzija ovir
NOvir=15;                    % stevilo ovir

MaxVel=10;                    % minimalna velikost stranice noda 
MinVel=.5;                    % minimalna velikost stranice noda 



% nakljucno dolocimo ovire
% x,y,fi,a,b  (sredina pravokotnika, zasuk, velikost stranice, velikost stranice)
ovire=zeros(NOvir,13);
ovire(:,1)=XMAX*rand(NOvir,1);
ovire(:,2)=YMAX*rand(NOvir,1);
ovire(:,3)=2*pi*rand(NOvir,1);
ovire(:,4)=XOvirMax*(rand(NOvir,1)+0.0);
ovire(:,5)=YOvirMax*(rand(NOvir,1)+0.0);
% vogalne toke ovir
 xo=[-ovire(:,4)/2,ovire(:,4)/2,ovire(:,4)/2,-ovire(:,4)/2];
 yo=[-ovire(:,5)/2,-ovire(:,5)/2,ovire(:,5)/2,ovire(:,5)/2];
 for i=1:size(ovire,1)
           ovire(i,6:9)  =ovire(i,1)*ones(1,4)+xo(i,:)*cos(ovire(i,3))-yo(i,:)*sin(ovire(i,3));
           ovire(i,10:13)=ovire(i,2)*ones(1,4)+xo(i,:)*sin(ovire(i,3))+yo(i,:)*cos(ovire(i,3));
 end




drawQT([], ovire) ; axis([0 XMAX 0 YMAX])
title('Ovire v okolju 3x3m')






%========================== naredimo quadtree (stirisko drevo)
h=msgbox('Quadtree. Animacija po korakih.',' ');
uiwait(h);

MaxVel=MaxVel;                    % maks velikost stranice noda 
MinVel=MaxVel/2^4;                    % minimalna velikost stranice noda 

% doloi Quadtree
if Animacija   % animacija
   [drevo] = quadTreeDekompozicija(ovire, MinVel,MaxVel, 0,XMAX,0,YMAX,1,1); % animacija
else
   [drevo] = quadTreeDekompozicija(ovire, MinVel, MaxVel, 0,XMAX,0,YMAX,0,0); % brez izrisa
   drawQT(drevo, ovire) ;
end

%========================== dodamo visibility graf
h=msgbox('visibility graf',' ');
uiwait(h);

drawQTVisibility(drevo, ovire);  

%========================== optimalna pot v QT
h=msgbox('Optimalna pot v QT: Izberi zacetek in konec s klikom na QT. Animacija po korakih.',' ');
uiwait(h);

drawQT(drevo, ovire);  
[xSE,ySE]=ginput(2); 
hold on
plot(xSE(1),ySE(1),'o')
plot(xSE(2),ySE(2),'x')
hold off

% find indexes of start node
nodeS=QT_findNodeId(xSE(1),ySE(1),0,XMAX,0,YMAX,drevo);
% find indexes of end node
nodeE=QT_findNodeId(xSE(2),ySE(2),0,XMAX,0,YMAX,drevo);


% use A* to find optimal path between start and end node
if Animacija
   Optimal_path = findOptimalPathDemo(nodeS,nodeE,drevo,XMAX,YMAX,1); % izris
   Optimal_path = findOptimalPath(nodeS,nodeE,drevo,XMAX,YMAX,0);
else
   Optimal_path = findOptimalPath(nodeS,nodeE,drevo,XMAX,YMAX,0);
   drawQT(drevo, ovire);
   drawOptimalPath(Optimal_path,drevo(nodeS).center(1),drevo(nodeS).center(2),drevo,1,[0 0 1]);
end

%========================== narisi koridor
h=msgbox('Narisi koridor',' ');
uiwait(h);

drawQT(drevo, ovire);  
drawOptimalPath(Optimal_path,drevo(nodeS).center(1),drevo(nodeS).center(2),drevo,1,[0 0 1]);
hold on
plot(xSE(1),ySE(1),'o')
plot(xSE(2),ySE(2),'x')
hold off


DD=TestPathReshape(xSE,ySE,Optimal_path,nodeS,nodeE,drevo,ovire);
% doloci zgornjo in spodnjo mejo koridorja
[zgoraj, spodaj,xx,yy]=TestRavnajPot(DD);
NarisiKoridorDebelina(zgoraj, spodaj,xx,yy,2);






%========================== minimalna pot v koridorju
h=msgbox('Minimalna pot v koridorju',' ');
uiwait(h);
drawQT(drevo, ovire);  
NarisiKoridorDebelina(zgoraj, spodaj,xx,yy,2);
%drawOptimalPath(Optimal_path,drevo(nodeS).center(1),drevo(nodeS).center(2),drevo,2,'r');

%path=FunnelPathDemo(DD(1).center,DD(end).center,DD);  % animacija

% poisci optimalni pot v koridorju - Funnel algorithem
path=FunnelPath(DD(1).center,DD(end).center,DD);


%drawQT(drevo, ovire);  
line(path(:,1),path(:,2),'Color','m','LineWidth',3)

%========================== konec





