function path=zravnaj_pot(a,b,seq,tri,x,y)

% funkcija izracuna optimalno pot od a do b znotraj koridorja, podanega s
% sekvenco trikotnikov seq (indeksi, ki kazejo na tri; tam indeksi, ki
% kazejo na x,y)
%
% path je v obliki matrike nx2 kjer vsaka vrstica pomeni eno tocko na poti

% implementiram "funnel algorithm" (po opisu v M. Kallman: Path Planning in
% Triangulations)

% dodam tocki v seznam koordinat
x=[x;a(1);b(1)];
y=[y;a(2);b(2)];

% zacetna tocka je predzadnja v seznamu
ip=length(x)-1;
if length(seq)>1,
    % prva stranica ki jo pot precka:
    uv=intersect(tri(seq(1),:),tri(seq(2),:));
    % test orientacije
    sredina=[1/2*(sum(x(uv)));1/2*(sum(y(uv)))];
    if p_side(sredina,[a',[x(uv(1));y(uv(1))]])>0
        deque_sp=[ip,uv(1)];
        deque_zg=[ip,uv(2)];
    else
        deque_sp=[ip,uv(2)];
        deque_zg=[ip,uv(1)];
    end;
%    for i=2:length(seq)-1,
    for i=2:length(seq),
        if i<length(seq),
            % tretje oglisce
            w=setdiff(tri(seq(i),:),uv);
            % kam s to tocko?
            % najprej moram ugotoviti, kateremu robu pripada (na koncu problem?)
            spodaj=true;
            if any(tri(seq(i+1),:)==deque_sp(end)),
                spodaj=false;
            end;
        else
            % tudi zadnjo tocko moram pretestirati (ce gre slucajno za
            % vogal)
            w=length(x);
            % tu je v bistvu vseeno, na kateri rob jo postavim, vazno pa,
            % da to upostevam na koncu...
            spodaj=true;
        end;
        wxy=[x(w);y(w)];
        if spodaj,
            for j=length(deque_sp):-1:2,
                % testiram daljice (j,j-1) na spodnjem robu
                pj=[x(deque_sp(j));y(deque_sp(j))];
                pj1=[x(deque_sp(j-1));y(deque_sp(j-1))];
                if p_side(wxy,[pj1,pj])>0,
                    deque_sp(j)=[];
                end;
            end;
            % testirati pa moram tudi zgornji rob, s tem da grem zdaj z
            % druge strani
            for j=1:length(deque_zg)-1,
                % testiram daljice (j,j+1) na zgornjem robu
                pj=[x(deque_zg(j));y(deque_zg(j))];
                pj1=[x(deque_zg(j+1));y(deque_zg(j+1))];
                if p_side(wxy,[pj,pj1])>0,
                    % to se lahko zgodi le, e sem spodaj pocistil ze vse razen
                    % apexa, zato zdaj postavim novi apex (brisem pa ne takoj,
                    % ker se mi bodo pokvarili indeksi)
                    deque_sp(1)=deque_zg(j+1);
                end;
            end;
            % zdaj pobrisem vse do novega apexa
            [temp,ai]=find(deque_zg==deque_sp(1));
            ip=[ip,deque_zg(2:ai)];
            deque_zg(1:ai-1)=[];
            % na koncu dodam w
            deque_sp(end+1)=w;
            % in popravim uv
            uv=[w,deque_zg(end)];
        else
            % zadeva za zgornji rob je simetricna
            for j=length(deque_zg):-1:2,
                % testiram daljice (j,j-1) na zgornjem robu
                pj=[x(deque_zg(j));y(deque_zg(j))];
                pj1=[x(deque_zg(j-1));y(deque_zg(j-1))];
                if p_side(wxy,[pj1,pj])<0,
                    deque_zg(j)=[];
                end;
            end;
            % testirati pa moram tudi spodnji rob, s tem da grem zdaj z
            % druge strani
            for j=1:length(deque_sp)-1,
                % testiram daljice (j,j+1) na spodnjem robu
                pj=[x(deque_sp(j));y(deque_sp(j))];
                pj1=[x(deque_sp(j+1));y(deque_sp(j+1))];
                if p_side(wxy,[pj,pj1])<0,
                    % to se lahko zgodi le, e sem zgoraj pocistil ze vse razen
                    % apexa, zato zdaj postavim novi apex (brisem pa ne takoj,
                    % ker se mi bodo pokvarili indeksi)
                    deque_zg(1)=deque_sp(j+1);
                end;
            end;
            % zdaj pobrisem vse do novega apexa
            [temp,ai]=find(deque_sp==deque_zg(1));
            ip=[ip,deque_sp(2:ai)];
            deque_sp(1:ai-1)=[];
            % na koncu dodam w
            deque_zg(end+1)=w;
            % in popravim uv
            uv=[deque_sp(end),w];
        end;
        %line(x(ip),y(ip),'Color','m','LineWidth',2);
        %line(x(deque_sp),y(deque_sp),'Color','b','LineWidth',2);
        %line(x(deque_zg),y(deque_zg),'Color','b','LineWidth',2);
        %drawnow;
        %pause
    end;
end;
% dodam se b
%ip=[ip,length(x)];
% zadnjo tocko sem dal na spodnji rob; v nekaterih primerih je treba
% upostevati vec tock na tem robu...
ip=[ip,deque_sp(2:end)];
path=[x(ip),y(ip)];



function s=p_side(point,line)

% pove, na kateri strani premice je tocka
% s=1 pomeni zgoraj, ce line podan s tockama, kjer je prva leva, druga desna
% s=-1 pomeni spodaj
% s=0 pomeni na premici

% point je podan kot stolpni vektor [x;y]
% line kot matrika [x1 x2;y1 y2]

% obravnavana je tocka p=[x y]'
% stranica pa [av bv]
a=line(:,2)-line(:,1); % [x2-x1;y2-y1]
b=point-line(:,1);     % [x-x1;y-y1]
% upostevam predznak razdalje do daljice (razdalja brez abs in brez /sqrt(a'*a))
s_p=-(a(2)*b(1)-a(1)*b(2));
s=sign(s_p);
